#include "quaternion.h"

struct Tetrahedron {
  int p1, p2, p3, p4;
};

struct Spring {
  int p1, p2;
};

struct Mesh {
  Integration integration;
  DclFloat  r, g, b;

  DclVector position;
  DclVector positionInit;
  DclVector velocity;

  DclMatrix33 I;  // inertia tensor
  DclMatrix33 Iinv; // inverted inertia tensor
  DclFloat  mass;
  DclVector force;  // force on cm
  DclMatrix33 orientation;  // orientation matrix
  DclVector angularVelocity;  // angular velocity vector
  DclVector torque; // torque on cm

  std::vector<Tetrahedron> vectorTetrahedra;
  std::vector<Spring> vectorSprings;
  std::vector<Particle> vectorParticles;
};

extern std::vector<Mesh> vectorMeshes;